<template>
  <NuxtLayout :name="'auth'">
    <div class="w-full mx-auto bg-transparent flex">
      <div class="w-full bg-white p-8 rounded-xl shadow-xl mx-auto mb-10">
        <h1 class="text-4xl mb-8 text-center text-slate-900 lg:hidden">
          Aplikasi Manajemen PDF
        </h1>
        <DynamicForm :isLoading="isLoading" :fields="fields" :formTitle="formTitle" :submitName="submitName"
          :onSubmit="onSubmit" />
        <hr class="my-2" />
        <div class="mb-4 w-full flex">
          <div class="w-1/2">
            <span class="block">
              Already have account?
              <NuxtLink class="block text-blue-500" to="/login">Login</NuxtLink>
            </span>
          </div>
          <div class="w-1/2">
            <span class="block">
              <a class="block text-right text-yellow-500" href="#">Forgot password?</a>
            </span>
          </div>
        </div>
      </div>
    </div>
  </NuxtLayout>
</template>

<script lang="ts">
interface formTemplate {
  name: string;
  username: string;
  email: string;
  password: string;
  salary: number;
}

export default {
  data() {
    return {
      formTitle: "Register",
      submitName: "Register",
      isLoading: false,
      fields: [
        { id: "name", name: "Nama", type: "text", value: "" },
        {
          id: "gender", name: "Jenis Kelamin", type: "select", value: "", options: [
            { name: 'Pilih Kelamin', value: '' },
            { name: 'Laki-laki', value: 'male' },
            { name: 'Perempuan', value: 'female' }
          ]
        },
        { id: "birth_place", name: "Tempat Lahir", type: "text", value: "" },
        { id: "birth_date", name: "Tanggal Lahir", type: "date", value: "" },
        { id: "nik", name: "NIK", type: "text", value: "" },
        { id: "nationality", name: "Kewarganegaraan", type: "text", value: "" },
        { id: "religion", name: "Agama", type: "text", value: "" },
        { id: "job", name: "Pekerjaan", type: "text", value: "" },
        { id: "address", name: "Alamat", type: "text", value: "" },
        { id: "username", name: "Username", type: "text", value: "" },
        { id: "email", name: "Email", type: "email", value: "" },
        { id: "password", name: "Password", type: "password", value: "" },
        { id: "salary", name: "Salary", type: "number", value: "" },
      ],
    };
  },
  methods: {
    onSubmit(data: formTemplate) {
      this.isLoading = true;
      const toastStore = useToastStore();

      this.$api
        .post(`/user/`, { ...data, role: 'warga' })
        .then((response) => {
          toastStore.showToast("Account created successfully", 'success')
          this.$router.push("/login");
        })
        .catch((error) => {
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          console.log(message)
          toastStore.showToast(message, 'danger')
        }).finally(() => {
          this.isLoading = false;
        })
    },
  },
};
</script>
